/***********************************************************************************
BEURTEILUNG von 1047450 für Aufgabe 1:  40 Punkte

        'pop':      10 -
        'reverse':  10 -
        'toString': 10 -
        'main':     10 -


Beispiel der wesentlichen Teile einer Lösung:

    class Node {
        ...

        private Node reverse() {
            if (this.next == null) {
                return this;
            }
            Node tail = this.next.reverse();
            this.next.next = this;
            this.next = null;
            return tail;

        }

        @Override
        public String toString() {
            Node node = this;
            String result = "";
            while (node.next != null) {
                result += node.elem + ",";
                node = node.next;
            }
            result += node.elem;
            return result;
        }

    } // End of the definition of Node

    ...

    public String pop() {
        if (head == null) {
            return null;
        }
        String result = head.elem;
        head = head.next;
        return result;
    }

    public void reverse() {
        head = head == null ? null : head.reverse();

    }

    @Override
    public String toString() {
        if (head == null) {
            return "[]";
        }
        return "[" + head + "]";
    }

    public static void main(String[] args) {
        List list = new List();

        list.push("d");
        list.push("c");
        list.push("b");
        list.push("a");
        System.out.println(list);

        System.out.println(list.pop());
        System.out.println(list);

        list.reverse();
        System.out.println(list);

        System.out.println(list.pop());
        System.out.println(list);
    }

***********************************************************************************/
/*
Lesen Sie die Aufgaben genau durch.
Verändern Sie die in den Aufgaben beschriebenen Programmstellen.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!

Achtung: Vorgegebene Testfälle überprüfen nur die Syntax. Sie überprüfen nicht die Korrektheit der Lösungen.
*/
public class List {

    /*
    Aufgabe:
        Objekte der Klasse List stellen verkettete Listen von Strings mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile entsprechend den Kommentaren an den mit TODO: gekennzeichneten Stellen.

    Punkte (maximal 40):
        10 Punkte für pop,
        10 Punkte für reverse,
        10 Punkte für toString,
        10 Punkte für main
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */

    class Node {

        // Do not change the object variables.  Do not add further object variables.
        private String elem;
        private Node next;

        // Do not change the constructor.
        private Node(String elem, Node next) {
            this.elem = elem;
            this.next = next;
        }

        // TODO: Define here methods of Node (if needed).

        public Node reverse()
        {
            if (next == null)
            {
                return this;
            }
            Node temp = next.reverse();
            next.next = this;
            next = null;
            return temp;
        }

        public String toString()
        {
            return elem + (next == null ? "" : "," + next);
        }

    } // End of the definition of Node

    // Initially the list is empty.
    private Node head = null;

    // Adds a string as first element to the list;  a call of pop() directly after push("x") returns "x".
    public void push(String elem) {
        head = new Node(elem, head);
    }

    // Removes and returns the first element of the list;  the result is null if the list is empty.
    public String pop() {
        // TODO: Implementation is your task
        if (head == null) return null;
        String temp = head.elem;
        head = head.next;
        return temp;
    }

    // Reverses the order of this list; if p.toString() returns "[x,y,z]" for a list p,
    // then directly after p.reverse() the call p.toString() returns "[z,y,x]".
    public void reverse() {
        // TODO: Implementation is your task
        if (head == null)
        {
            return;
        }
        else
        {
            head = head.reverse();
        }
    }

    // Returns a comma-separated list of the elements in square brackets;  for example, if the list contains
    // "x" (as first element), "y" and "z" (as last element), then toString() returns "[x,y,z]";
    // for an empty list the result is "[]".
    @Override
    public String toString() {
        // TODO: Implementation is your task
        if(head == null)
        {
            return "[]";
        }
        else
        {
            return "[" + head + "]";
        }
    }

    // TODO: Complete main as described in the TODO comments.
    public static void main(String[] args) {
        List list = new List();
        // TODO: Call push 4 times such that the following statement prints: [a,b,c,d]
        list.push("d");
        list.push("c");
        list.push("b");
        list.push("a");
        System.out.println(list);

        // TODO: Call pop on 'list' and print a line with the removed element;
        System.out.println(list.pop());
        // TODO: print another line with the content of 'list'.
        System.out.println(list);
        // TODO: Reverse the list by calling reverse() on 'list' and print the content of 'list'.
        list.reverse();
        System.out.println(list);
        // TODO: Call pop() on 'list' and print a line with the removed element;
        System.out.println(list.pop());
        // TODO: print another line with the content of 'list'.
        System.out.println(list);


    }

}

