/***********************************************************************************
BEURTEILUNG von 1047450 für Aufgabe 2:  30 Punkte

        'sumLevel': (10/10 P)
        'maxDiff':  (10/10 P)
        'toString': (10/10 P)


Beispiel der wesentlichen Teile einer Lösung:

    class Node {
        ...

        private int sumLevel(int level) {
            if(level == 0) {
                return this.elem;
            }
            int left = 0;
            int right = 0;
            if (this.left != null) {
                left = this.left.sumLevel(level - 1);
            }
            if (this.right != null) {
                right = this.right.sumLevel(level - 1);
            }
            return left + right;
        }

        @Override
        public String toString() {
            String result = Integer.toString(elem);
            if (left != null) {
                result = left + "," + result;
            }
            if (right != null) {
                result += "," + right;
            }
            return result;
        }

    } // End of the definition of Node

    ...

    public int sumLevel(int level) {
        if(root == null) {
            return 0;
        }
        return root.sumLevel(level);
    }

    public int maxDiff() {
        if (root == null) {
            return 0;
        }
        Node smallest = root;
        while (smallest.left != null) {
            smallest = smallest.left;
        }
        Node largest = root;
        while (largest.right != null) {
            largest = largest.right;
        }
        return largest.elem - smallest.elem;
    }

    @Override
    public String toString() {
        if (root == null) {
            return "[]";
        }
        return "[" + root + "]";
    }

***********************************************************************************/
public class Tree {

    /*
    Aufgabe:
        Objekte der Klasse Tree stellen binäre Suchbäume über ganzen Zahlen mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 30):
        10 Punkte für sumLevel,
        10 Punkte für maxDiff,
        10 Punkte für toString.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    class Node {

        // Do not change these variables and the constructor.  Do not add further variables and constructors here.
        private int elem;
        private Node left;
        private Node right;

        // Do not change the constructor.
        private Node(int elem) {
            this.elem = elem;
        }

        // Do not change this method.
        private void add(int elem) {
            if (elem < this.elem) {
                if (left == null) {
                    left = new Node(elem);
                } else {
                    left.add(elem);
                }
            } else {
                if (right == null) {
                    right = new Node(elem);
                } else {
                    right.add(elem);
                }
            }
        }


        // TODO: Define further methods of Node here (if needed).
        public int sumLevel(int level)
        {
            if (level == 0)
            {
                return elem;
            }
            else if (left == null && right == null)
            {
               return 0;
            }
            else
            {
                int sum = 0;
                if (left != null) sum += left.sumLevel(level - 1);
                if (right != null) sum += right.sumLevel(level - 1);
                return sum;
            }
        }

        public int getLowest()
        {
            if (left == null) return elem;
            else return left.getLowest();
        }

        public int getHighest()
        {
            if (right == null) return elem;
            else return right.getHighest();
        }

        public String toString()
        {
            String out = elem + "";

            if (left != null) out = left.toString() + "," + elem;
            if (right != null) out += "," + right;
            return out;
        }

    } // End of the definition of Node

    // The root of the tree.  Do not change or add object variables.
    private Node root;

    // Adds elem to the tree if it is not already in the tree.  Do not change this method.
    public void add(int elem) {
        if (root == null) {
            root = new Node(elem);
        } else {
            root.add(elem);
        }
    }

    // Returns sum of the elements in the specified level >= 0 of the tree;
    // for example, if the tree 't' looks like:
    //         5
    //        / \
    //       2   7
    //      /   / \
    //     1   6   8
    // then the result of 't.sumLevel(0)' is "5"
    // and the result of 't.sumLevel(1)' is "9"
    // and the result of 't.sumLevel(2)' is "15"
    // and the result of 't.sumLevel(3)' is "0";
    // for an empty tree or if the tree has no elements in the specified level the result is "0".
    public int sumLevel(int level) {
        // TODO: Implementation is your task
        if (root == null || level < 0)
        {
            return 0;
        }
        else
        {
            return root.sumLevel(level);
        }
    }

    // Returns the difference between the largest and smallest value in the tree;
    // if possible, only a small part of the tree is visited;
    // the result is 0 if the tree is empty or contains only one element.
    public int maxDiff() {
        // TODO: Implementation is your task
        if (root == null) return 0;
        else return root.getHighest() - root.getLowest();
    }

    // Returns a comma-separated list of the elements in ascending order (aufsteigend sortiert) within square brackets;
    // for example, if the tree contains 1, 2, 3 and 4, the result ist "[1,2,3,4]" (independent of the structure of the
    // tree);  for an empty tree the result is "[]".
    @Override
    public String toString() {
        // TODO: Implementation is your task
        if (root == null)
        {
            return "[]";
        }
        else
        {
            return "[" + root + "]";
        }
    }

    // Just for testing, not used for assessment (geht nicht in die Beurteilung ein).
    public static void main(String[] args) {
        Tree tree = new Tree();

        System.out.println(tree);
        System.out.println(tree.maxDiff());
        System.out.println(tree.sumLevel(2));
        System.out.println(tree.sumLevel(0));
        System.out.println(tree.sumLevel(-2));
        tree.add(5);
        tree.add(2);
        tree.add(7);
        tree.add(1);
        tree.add(6);
        tree.add(8);

        System.out.println(tree);
        System.out.println(tree.maxDiff());
        System.out.println("--------");
        System.out.println(tree.sumLevel(-1));
        System.out.println(tree.sumLevel(0));
        System.out.println(tree.sumLevel(1));
        System.out.println(tree.sumLevel(2));
        System.out.println(tree.sumLevel(3));
        System.out.println("------");
        Tree tree2 = new Tree();
        tree2.add(15);
        tree2.add(10);
        tree2.add(8);
        tree2.add(5);
        tree2.add(0);
        System.out.println(tree2);
        Tree treee = new Tree();
        System.out.println("------------");
        System.out.println(treee.maxDiff());
        treee.add(125);
        System.out.println(treee.maxDiff());
        treee.add(1);
        System.out.println(treee.maxDiff());

    }

}

